/*******************************************************************************
 * FoxWeapon_DoubleMeleeBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_DoubleMeleeBase extends FoxWeapon_MeleeBase
    config(Knife)
    hidecategories(Navigation);

var byte CurrentAttackAnim;
var const array<WeaponAnimSet> AttackAnims;
var const config float QuickAnimPercentage;
var const config float QuickResetPercentage;
var const AkEvent StartSelectedAudio;
var const AkEvent StopSelectedAudio;
var name SparkFXName;
var name TrailFXName;
var export editinline ParticleSystemComponent TrailEmitter;

simulated function PostBeginPlay()
{
    // End:0x49
    if(TrailEmitter != none)
    {
        SkeletalMeshComponent(Mesh).AttachComponentToSocket(TrailEmitter, TrailFXName);
    }
    super(FoxWeapon).PostBeginPlay();
    //return;    
}

simulated event UpdateFirstPersonFOV(optional float NewFOV)
{
    NewFOV = -1.0;
    super(FoxWeapon_GrenadeBase).UpdateFirstPersonFOV(NewFOV);
    // End:0x40
    if(NewFOV < float(0))
    {
        NewFOV = FirstPersonFOV;
    }
    // End:0x89
    if(FoxFirstPersonParticleSystemComponent(TrailEmitter) != none)
    {
        FoxFirstPersonParticleSystemComponent(TrailEmitter).SetFOV(NewFOV);
    }
    //return;    
}

simulated event Destroyed()
{
    PlayAkEvent(StopSelectedAudio, true);
    super(FoxWeapon_GrenadeBase).Destroyed();
    //return;    
}

simulated function DeactivateEmissive()
{
    //return;    
}

simulated function StopQuickMeleeAnim()
{
    local WeaponAnimSet AttackAnim;

    AttackAnim = AttackAnims[CurrentAttackAnim];
    FoxPawn(Instigator).StopFirstAndThirdPersonAnim(AttackAnim.FP_Anim, AttackAnim.TP_Anim, AttackAnim.AbortBlendOutTime);
    //return;    
}

simulated function StopFireEffects(byte FireModeNum)
{
    //return;    
}

reliable server function ServerStartLunge()
{
    local float MeleeTime;

    // End:0x46
    if((CanMelee()) && !IsInState('LungeMelee'))
    {
        // End:0x38
        if(IsReloading())
        {
            global.AbortReload();
        }
        GotoState('LungeMelee');
    }
    IncrementMeleeAttempts();
    MeleeTime = StartFPMeleeAnim(true);
    SetFlashLocation(Instigator.Location);
    FoxPawn(Instigator).DoSpecialMove(21, false, false);
    FoxPawn(Instigator).SetSpecialMoveTimer(MeleeTime);
    //return;    
}

simulated function PullPinFinished()
{
    //return;    
}

simulated function StepZoom()
{
    StartMelee();
    //return;    
}

simulated function WeaponAnimSet GetWeaponAnimSet()
{
    // End:0x7C
    if(IsTimerActive('ResetWeaponAnimSet'))
    {
        ++ CurrentAttackAnim;
        // End:0x48
        if(CurrentAttackAnim >= AttackAnims.Length)
        {
            CurrentAttackAnim = 0;
        }
        // End:0x66
        if(CurrentAttackAnim == 3)
        {
            global.ClearAllPendingFire();
        }
        return AttackAnims[CurrentAttackAnim];
    }
    return AttackAnims[0];
    //return ReturnValue;    
}

simulated function ResetWeaponAnimSet()
{
    ClearTimer('ResetWeaponAnimSet');
    CurrentAttackAnim = 0;
    //return;    
}

simulated function float StartMeleeAnim(optional float PrecentOfAnimLength)
{
    local float MeleeTime;
    local WeaponAnimSet AttackAnim;

    PrecentOfAnimLength = 1.0;
    // End:0xE1
    if(CurrentFireMode == 2)
    {
        AttackAnim = GetWeaponAnimSet();
        MeleeTime = PlayWeaponSet(AttackAnim, 1.0, false, true);
        ClearTimer('StopQuickMeleeAnim');
        SetTimer(MeleeTime, false, 'StopQuickMeleeAnim');
        SetTimer(MeleeTime * QuickAnimPercentage, false, 'AllowNextMelee');
        ClearTimer('ResetWeaponAnimSet');
        SetTimer(MeleeTime * QuickResetPercentage, false, 'ResetWeaponAnimSet');
        return MeleeTime;
    }
    ResetWeaponAnimSet();
    return super(FoxWeapon).StartMeleeAnim();
    //return ReturnValue;    
}

simulated function AllowNextMelee()
{
    //return;    
}

simulated function name GetPostPullPinStateName()
{
    // End:0x53
    if(Instigator.IsLocallyControlled() || Instigator.IsBeingFPSpectatedByLocalController())
    {
        return 'LungeMelee';
    }
    // End:0x5D
    else
    {
        return 'None';
    }
    //return ReturnValue;    
}

simulated state WeaponEquipping
{
    simulated function BeginState(name PreviousStateName)
    {
        ActivateEmissive();
        PlayAkEvent(StartSelectedAudio, true);
        super.BeginState(PreviousStateName);
        //return;        
    }
    stop;    
}

simulated state Inactive
{
    simulated function BeginState(name PreviousStateName)
    {
        PlayAkEvent(StopSelectedAudio, true);
        // End:0x66
        if(TrailEmitter != none)
        {
            TrailEmitter.SetHidden(true);
            TrailEmitter.DeactivateSystem();
        }
        super.BeginState(PreviousStateName);
        //return;        
    }
    stop;    
}

simulated state Active
{
    simulated function BeginState(name PreviousStateName)
    {
        super.BeginState(PreviousStateName);
        // End:0x61
        if(TrailEmitter != none)
        {
            TrailEmitter.SetHidden(true);
            TrailEmitter.DeactivateSystem();
        }
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        // End:0x4F
        if(TrailEmitter != none)
        {
            TrailEmitter.SetHidden(false);
            TrailEmitter.ActivateSystem();
        }
        super(FoxWeapon).EndState(NextStateName);
        //return;        
    }
    stop;    
}

simulated state QuickMelee extends Melee
{
    simulated function BeginState(name PreviousStateName)
    {
        SetupSimulatedState();
        super.BeginState(PreviousStateName);
        //return;        
    }

    simulated function bool CanLunge()
    {
        return false;
        //return ReturnValue;        
    }

    simulated function StartFire(byte FireModeNum)
    {
        global.StartFire(FireModeNum);
        //return;        
    }

    simulated function AllowNextMelee()
    {
        GotoState('Active');
        //return;        
    }
    stop;    
}

simulated state LungeMelee extends Melee
{
    simulated function BeginState(name PreviousStateName)
    {
        StopZoomMode();
        bWantsToThrowGrenade = false;
        FoxPawn(Instigator).UpdateHandsIK();
        FoxInventoryManager(Instigator.InvManager).LockWeaponActionSemaphore();
        // End:0x166
        if((((Role == ROLE_Authority) && Instigator != none) && FoxPRI(Instigator.PlayerReplicationInfo) != none) && FoxPRI(Instigator.PlayerReplicationInfo).WeaponUsageStats != none)
        {
            FoxPRI(Instigator.PlayerReplicationInfo).WeaponUsageStats.IncrementMeleeAttempts();
        }
        BeginMelee();
        SetupSimulatedState();
        //return;        
    }

    simulated function BeginMelee()
    {
        local ImpactInfo Impact;

        ClearAllPendingFire();
        // End:0xD0
        if(Instigator.IsLocallyControlled() || Instigator.IsBeingFPSpectatedByLocalController())
        {
            // End:0x75
            if(CanLunge())
            {
                ServerStartLunge();
                StartFPMeleeAnim(true);
            }
            // End:0xD0
            else
            {
                GetPawnToMelee(false, Impact, class'FoxWeapon'.default.MeleeRange);
                SetMeleeTarget(none, Impact, bQuickThrow);
                StartFPMeleeAnim(true);
            }
        }
        //return;        
    }
    stop;    
}

defaultproperties
{
    AttackAnims(0)=(TP_Anim=(AnimName=(None,None,Melee_A)),FP_Anim=Melee_A,WP_Anim=Idle_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.250,AbortBlendOutTime=0.10)
    AttackAnims(1)=(TP_Anim=(AnimName=(None,None,Melee_B)),FP_Anim=Melee_B,WP_Anim=Idle_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.250,AbortBlendOutTime=0.10)
    AttackAnims(2)=(TP_Anim=(AnimName=(None,None,Melee_C)),FP_Anim=Melee_C,WP_Anim=Idle_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.250,AbortBlendOutTime=0.10)
    SparkFXName=S_SparksFX
    TrailFXName=S_TrailFX
    AN_PullPin=(FP_Anim=PrepareLunge,WP_Anim=PrepareLunge)
    AN_PinPulledIdle=(FP_Anim=PrepareLunge_Idle,WP_Anim=PrepareLunge_Idle)
    begin object name=GearFXParticleSystemComponent0 class=FoxFirstPersonParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonParticleSystemComponent'Default__FoxWeapon_DoubleMeleeBase.GearFXParticleSystemComponent0'
    GearFXComponent=GearFXParticleSystemComponent0
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_DoubleMeleeBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_DoubleMeleeBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_DoubleMeleeBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_DoubleMeleeBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.59080780
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_DoubleMeleeBase.LensComp'
    MuzzleLensFlare=LensComp
    AN_Melee=(TP_Anim=(AnimName=(None,None,Lunge_A)),FP_Anim=Lunge_A,WP_Anim=Lunge_A)
    AN_NormalFire=(TP_Anim=(AnimName=(None,None,Melee_A)),FP_Anim=Melee_A,WP_Anim=Idle_A,BlendOutTime=0.250,AbortBlendOutTime=0.10)
    FiringStatesArray=/* Array type was not detected. */
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_DoubleMeleeBase.WeaponMesh'
    Mesh=WeaponMesh
}